/***************************************************************************************
LANに情報を公開する
Arduino ETHERNET用
                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <SPI.h>
#include <Ethernet.h>

byte mac[]={0x90,0xA2,0xDA,0x00,0x00,0x00}; // Arduino EthernetのMACアドレスを記述する
IPAddress ip(192,168,0,101);                // ArduinoのIPアドレスをカンマ区切りで記述
EthernetServer server(80);                  // IPのポート番号を設定します(HTTPは80)
EthernetClient client;                      // クライアントの変数(インスタンス)を定義

void setup(){
    Ethernet.begin(mac, ip);                // Ethernetを開始する
    server.begin();                         // サーバ機能を開始する
}

void loop(){
    client = server.available();            // サーバへのアクセスを確認する
    if(client.available()){
        if(client.connected()){             // 送信が可能であれば以下の処理を実行する
            client.println("HTTP/1.1 200 OK");
            client.println("Content-Type: text/html");
            client.println("Connnection: close");
            client.println();
            client.println("<!DOCTYPE HTML>");
            client.println("<html><head>");
            client.println("<meta charset=\"UTF-8\">");
            client.println("<meta http-equiv=\"refresh\" content=\"1\">");
            client.println("</head><body>");
            client.println("<h1>Hello, world!</h1>");
            client.print("Arduino timer : ");
            client.print( millis() );
            client.println(" [ms]");
            client.println("</body></html>");
        }
        client.stop();                      // 接続終了
    }
}
