/***************************************************************************************
子機XBeeのスイッチ変化通知を受信する

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
byte dev[8];                                    // XBee子機のアドレス保存用

void setup() {
    lcd.begin(16, 2);                           // LCDのサイズを16文字×2桁に設定
    lcd.clear();                                // 画面消去
    lcd.print("Example 38 SW_R ");              // 文字を表示
    xbee_init( 0 );                             // XBee用COMポートの初期化
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    lcd.print("Waiting for XBee");              // 待ち受け中の表示
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    if(xbee_atnj(30) != 0){                     // デバイスの参加受け入れを開始
        lcd.print("Found a Device  ");          // XBee子機デバイスの発見表示
        xbee_from( dev );                       // 見つけた子機のアドレスを変数devへ
        xbee_ratnj(dev,0);                      // 子機に対して孫機の受け入れ拒否を設定
        xbee_gpio_init( dev );                  // 子機のDIOにIO設定を行う(送信)
    }else lcd.print("no Devices      ");        // 子機が見つからなかった
}

void loop() {
    XBEE_RESULT xbee_result;                    // 受信データ(詳細)

    xbee_rx_call( &xbee_result );               // データを受信
    if( xbee_result.MODE == MODE_GPIN){         // 子機XBeeのDIO入力
        lcd.clear();                            // 画面消去
        lcd.print("D1:");
        lcd.print(xbee_result.GPI.PORT.D1);     // 子機XBeeのポート1の状態を表示する
        lcd.print(" D2:");
        lcd.print(xbee_result.GPI.PORT.D2);     // 子機XBeeのポート2の状態を表示する
        lcd.print(" D3:");
        lcd.print(xbee_result.GPI.PORT.D3);     // 子機XBeeのポート3の状態を表示する
    }
}
