/***************************************************************************************
自作ブレッドボードセンサの測定値を自動送信する

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystal.h>
#define FORCE_INTERVAL  250                     // データ要求間隔(およそ10msの倍数)

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

void setup() {
    lcd.begin(16, 2);                           // LCDのサイズを16文字×2桁に設定
    lcd.clear();                                // 画面消去
    lcd.print("Example 45 SensR");              // 文字を表示
    xbee_init( 0 );                             // XBee用COMポートの初期化
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    xbee_atnj( 0xFF );                          // 子機XBeeデバイスを常に参加受け入れ
    lcd.print("Waiting for XBee");              // 待ち受け中の表示
}

void loop() {
    byte i;
    float value;                                // 受信データの代入用
    byte dev[8];                                // XBee子機のアドレス保存用
    XBEE_RESULT xbee_result;                    // 受信データ(詳細)
    
    /* データ受信(待ち受けて受信する) */
    xbee_rx_call( &xbee_result );               // データを受信
    switch( xbee_result.MODE ){                 // 受信したデータの内容に応じて
        case MODE_GPIN:                         // 子機XBeeの自動送信の受信
            // 照度測定結果をvalueに代入してprintfで表示する
            value = (float)xbee_result.ADCIN[1] * 3.55;
            lcd.clear();
            lcd.print(value, 1);
            lcd.print(" Lux");
            break;
        case MODE_IDNT:                         // 新しいデバイスを発見
            lcd.clear();
            lcd.print("Found New Device");
            for(i=0;i<8;i++) dev[i]=xbee_result.FROM[i];    // アドレスをdevにコピー
            xbee_ratnj(dev,0);                  // 子機に対して孫機の受け入れを拒否
            xbee_gpio_config( dev, 1 , AIN );   // XBee子機のポート1をアナログ入力へ
            xbee_end_device( dev, 3, 3, 0);     // 起動間隔3秒,自動測定3秒,S端子無効
            break;
    }
}
