/***************************************************************************************
自作ブレッドボードを使ったリモートブザー

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystalDFR.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
byte dev[8];                                    // XBee子機のアドレス保存用

void bell(byte c){
    byte i;
    for(i=0;i<c;i++){
        xbee_gpo( dev , 4 , 1 );                // 子機 devのポート4を1に設定(送信)
        xbee_gpo( dev , 4 , 0 );                // 子機 devのポート4を0に設定(送信)
    }
    xbee_gpo( dev , 4 , 0 );                    // 子機 devのポート4を0に設定(送信)
    delay(3000);
    xbee_gpo( dev , 4 , 0 );                    // 子機 devのポート4を0に設定(送信)
}

void setup() {
    lcd.begin(16, 2);                           // LCDのサイズを16文字×2桁に設定
    lcd.clear();                                // 画面消去
    lcd.print("Example 49 Bell ");              // 文字を表示
    xbee_init( 0 );                             // XBee用COMポートの初期化
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    lcd.print("Waiting for XBee");              // 待ち受け中の表示
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    while( xbee_atnj(30)==0x00 );               // 子機XBeeデバイスのペアリング
    lcd.print("Found a Device  ");              // XBee子機デバイスの発見表示
    xbee_from( dev );                           // 見つけた子機のアドレスを変数devへ
    bell( 3 );                                  // ブザーを3回ならす
    xbee_end_device( dev, 3, 0, 0);             // 起動間隔3秒,自動測定無効,S端子無効
}

void loop() {
    lcd.setCursor(0, 1);
    switch( lcd.readButtons() ){                // 押されたボタンに対して
        case BUTTON_DOWN:
            lcd.print("DOWN            ");      // 下ボタンの時にDOWNと表示
            bell( 1 );                          // ブザーを1回、鳴らす
            break;
        case BUTTON_LEFT:
            lcd.print("LEFT            ");      // 左ボタンの時にLEFTと表示
            bell( 2 );                          // ブザーを2回、鳴らす
            break;
        case BUTTON_RIGHT:
            lcd.print("RIGHT           ");      // 右ボタンの時にRIGHTと表示
            bell( 3 );                          // ブザーを3回、鳴らす
            break;
        case BUTTON_UP:
            lcd.print("UP              ");      // 上ボタンの時にUPと表示
            bell( 4 );                          // ブザーを4回、鳴らす
            break;
        default:
            lcd.print("Hit any Key     ");      // その他の時に表示
    }
}
