/***************************************************************************************
XBeeスイッチとXBeeブザーで玄関呼鈴を製作する

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
byte dev_bell[8];                           // XBee子機(ベル)デバイスのアドレス
byte dev_sw[8];                             // XBee子機(スイッチ)デバイスのアドレス

void setup() {
    lcd.begin(16, 2);                       // LCDのサイズを16文字×2桁に設定
    lcd.clear();                            // 画面消去
    lcd.print("Example 50-2 Bel");          // 文字を表示
    xbee_init( 0 );                         // XBee用COMポートの初期化
    lcd.setCursor(0, 1);                    // LCDのカーソル位置を2行目の先頭に
    lcd.print("Waiting for Bell");
    xbee_atnj(30);                          // デバイスの参加受け入れ
    xbee_from( dev_bell );                  // 見つけた子機のアドレスを変数devへ
    lcd.setCursor(0, 1);                    // LCDのカーソル位置を2行目の先頭に
    lcd.print("Waiting for SW  ");
    xbee_atnj(30);                          // デバイスの参加受け入れ
    lcd.clear();                            // 画面消去
    xbee_from( dev_sw );                    // 見つけた子機のアドレスを変数devへ
    xbee_gpio_init( dev_sw );               // 子機のDIOにIO設定を行う
    xbee_end_device(dev_sw, 20, 0, 1);      // 起動間隔20秒,自動測定OFF,SLEEP端子有効
    lcd.print("Press Switch");
}

void loop() {
    byte i=0;
    XBEE_RESULT xbee_result;                        // 受信データ(詳細)

    xbee_rx_call( &xbee_result );                   // データを受信
    switch( xbee_result.MODE ){                     // 受信したデータの内容に応じて
        case MODE_GPIN:                             // 子機XBeeの自動送信の受信
            if(xbee_result.GPI.PORT.D1 == 0) i=1;   // ポート1が押された
            lcd.clear();                            // 画面消去
            lcd.print("SW:");
            lcd.print(i);
            for(i*=10; i>0 ; i--){
                xbee_gpo( dev_bell , 4 , 1 );       // 子機 devのポート4を1に設定
                xbee_gpo( dev_bell , 4 , 0 );       // 子機 devのポート4を0に設定
            }
            xbee_gpo( dev_bell , 4 , 0 );
            break;
    }
}
